/*
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import tdt4250.ra.rax1.Course;
import tdt4250.ra.rax1.Department;
import tdt4250.ra.rax1.Person;
import tdt4250.ra.rax1.Rax1Package;
import tdt4250.ra.rax1.ResourceAllocation;
import tdt4250.ra.services.Rax1GrammarAccess;

@SuppressWarnings("all")
public class Rax1SemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private Rax1GrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == Rax1Package.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case Rax1Package.COURSE:
				sequence_Course(context, (Course) semanticObject); 
				return; 
			case Rax1Package.DEPARTMENT:
				sequence_Department(context, (Department) semanticObject); 
				return; 
			case Rax1Package.PERSON:
				sequence_Person(context, (Person) semanticObject); 
				return; 
			case Rax1Package.RESOURCE_ALLOCATION:
				sequence_ResourceAllocation(context, (ResourceAllocation) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Course returns Course
	 *
	 * Constraint:
	 *     (code=ID name=NameOrString (allocations+=ResourceAllocation allocations+=ResourceAllocation*)?)
	 */
	protected void sequence_Course(ISerializationContext context, Course semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Department returns Department
	 *
	 * Constraint:
	 *     (shortName=ID name=STRING persons+=Person* courses+=Course*)
	 */
	protected void sequence_Department(ISerializationContext context, Department semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Person returns Person
	 *
	 * Constraint:
	 *     name=NameOrString
	 */
	protected void sequence_Person(ISerializationContext context, Person semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, Rax1Package.Literals.PERSON__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, Rax1Package.Literals.PERSON__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getPersonAccess().getNameNameOrStringParserRuleCall_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     ResourceAllocation returns ResourceAllocation
	 *
	 * Constraint:
	 *     (person=[Person|NameOrString] percentage=INT)
	 */
	protected void sequence_ResourceAllocation(ISerializationContext context, ResourceAllocation semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, Rax1Package.Literals.RESOURCE_ALLOCATION__PERSON) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, Rax1Package.Literals.RESOURCE_ALLOCATION__PERSON));
			if (transientValues.isValueTransient(semanticObject, Rax1Package.Literals.RESOURCE_ALLOCATION__PERCENTAGE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, Rax1Package.Literals.RESOURCE_ALLOCATION__PERCENTAGE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getResourceAllocationAccess().getPersonPersonNameOrStringParserRuleCall_0_0_1(), semanticObject.eGet(Rax1Package.Literals.RESOURCE_ALLOCATION__PERSON, false));
		feeder.accept(grammarAccess.getResourceAllocationAccess().getPercentageINTTerminalRuleCall_1_0(), semanticObject.getPercentage());
		feeder.finish();
	}
	
	
}
